#include once "glfw3.bi"

sub _init constructor
  if glfwInit()=GL_FALSE then
    print "error: can't init GLFW"
    beep : sleep : end 1
  end if
end sub

sub _exit destructor
  glfwTerminate()
end sub

sub FramebuffersizefunCB GLFWCALLBACK (win as GLFWwindow ptr, w as long,h as long)
  glViewport 0,0,w,h
end sub

'
' main
'
' get primary monitor
var monitor = glfwGetPrimaryMonitor()

' get current videomode from primary monitor
var mode = glfwGetVideoMode(monitor)

' set window hints from current mode
glfwWindowHint GLFW_RED_BITS    , mode->redBits
glfwWindowHint GLFW_GREEN_BITS  , mode->greenBits
glfwWindowHint GLFW_BLUE_BITS   , mode->blueBits
glfwWindowHint GLFW_REFRESH_RATE, mode->refreshRate
glfwWindowHint GLFW_DOUBLEBUFFER, GL_TRUE

' create a fullscreen OpenGL window on primary monitor
var win = glfwCreateWindow(mode->width,mode->height,"GLFW fullscreen",monitor)

' make it the current
glfwMakeContextCurrent win

' set buffer resize callback
glfwSetFramebufferSizeCallback win,@FramebuffersizefunCB

' press [ESC] or press [ALT] + [F4]
while glfwWindowShouldClose(win)=GL_FALSE andalso glfwGetKey(win,GLFW_KEY_ESCAPE)=GL_FALSE
  dim as double t=glfwGetTime()
  glClearColor(.5+cos(t)*.5, 0, 0,1)
  glClear GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT

  '
  ' draw your scene
  '

  glfwSwapBuffers win ' copy buffer on screen
  glfwPollEvents ' handle OS events (window, keyboard, joystick, mouse ...)
  sleep 10
wend
' destroy it 
glfwDestroyWindow(win)

' free all resources
glfwTerminate()


